#ifndef HTTPWINDOW_H
#define HTTPWINDOW_H

#include <QNetworkAccessManager>
#include <QUrl>
#include <QNetworkReply>
QT_BEGIN_NAMESPACE
class QSslError;
class QAuthenticator;
class QNetworkReply;


QT_END_NAMESPACE

class HttpWindow : public QObject
{
    Q_OBJECT

public:
    HttpWindow(QObject *parent = 0);

    void startRequest(QUrl url);

private slots:
    void httpFinished();
    void httpReadyRead();
    void updateDataReadProgress(qint64 bytesRead, qint64 totalBytes);
    void slotAuthenticationRequired(QNetworkReply*,QAuthenticator *);
    void replyFinished(QNetworkReply* r);
    void networkAccessibleChanged ( QNetworkAccessManager::NetworkAccessibility a);
    void replyError ( QNetworkReply::NetworkError code );
#ifndef QT_NO_OPENSSL
    void sslErrors(QNetworkReply*,const QList<QSslError> &errors);
#endif

private:
    QNetworkAccessManager qnam;
    QNetworkReply *reply;
};

#endif
