#include <sys/types.h>
#include <sys/socket.h>
#include <signal.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


#include <errno.h>
#include <signal.h>
#include <time.h>
#include <ctype.h>


int main(void)
{
  struct sockaddr_in stSockAddr;
  int SocketFD = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);

  if(-1 == SocketFD)
  {
    perror("can not create socket");
    exit(EXIT_FAILURE);
  }

  memset(&stSockAddr, 0, sizeof(stSockAddr));

  stSockAddr.sin_family = AF_INET;
  stSockAddr.sin_port = htons(1100);
  stSockAddr.sin_addr.s_addr = INADDR_ANY;

  if(-1 == bind(SocketFD,(struct sockaddr *)&stSockAddr, sizeof(stSockAddr)))
  {
    perror("error bind failed");
    close(SocketFD);
    exit(EXIT_FAILURE);
  }

  if(-1 == listen(SocketFD, 10))
  {
    perror("error listen failed");
    close(SocketFD);
    exit(EXIT_FAILURE);
  }

  for(;;)
  {
    printf("awaiting connection\n");
    int ConnectFD = accept(SocketFD, NULL, NULL);
    signal(SIGPIPE,SIG_IGN);
    
    printf("accepted connection...\n");
    if(0 > ConnectFD)
    {
      perror("error accept failed");
      close(SocketFD);
      exit(EXIT_FAILURE);
    }

    char foo[256];
    int count=snprintf(foo,256,"HTTP/1.0 200 OK\r\nContent-Type: text/plain\r\n\r\n");
    int written=write(ConnectFD, foo, count);
    printf("wrote %i/%i header bytes\n", written, count);

    int c=0;
    while(1) {
      sleep(1);
      int count=snprintf(foo,256,"%i\n", c++);
      int written=write(ConnectFD, foo, count);
      printf("wrote %i/%i data bytes\n", written, count);
      if(written != count) {
        printf("write failed, closing...\n");
        break;
      }
    }
    if (-1 == shutdown(ConnectFD, SHUT_RDWR))
    {
      perror("can not shutdown socket");
      close(ConnectFD);
      exit(EXIT_FAILURE);
    }
    close(ConnectFD);
  }
  return EXIT_SUCCESS;  
}
